// Generated by CoffeeScript 1.7.1
(function() {
  var Match, NoMatch, ParserState, alt, chain, check, commit, defer, drop, helpers, implicit, not_, optional, parser, parser_state, reduce, repeat, repeatIgnore, repeatSeparated, resolve, seq, seqIgnore, util,
    __slice = [].slice;

  util = require('util');

  helpers = require('./helpers');

  parser = require('./parser');

  parser_state = require('./parser_state');

  defer = helpers.defer;

  implicit = helpers.implicit;

  resolve = helpers.resolve;

  ParserState = parser_state.ParserState;

  Match = parser_state.Match;

  NoMatch = parser_state.NoMatch;

  optional = function(p, defaultValue) {
    if (defaultValue == null) {
      defaultValue = "";
    }
    p = implicit(p);
    return parser.newParser("optional", {
      nested: [p],
      describer: function(ps) {
        return "optional(" + (ps.join()) + ")";
      },
      matcher: function(state, cont) {
        p = resolve(p);
        return p.parse(state, function(rv) {
          if (rv.ok || rv.abort) {
            return cont(rv);
          }
          return cont(new Match(state, defaultValue, rv.commit));
        });
      }
    });
  };

  check = function(p) {
    p = implicit(p);
    return parser.newParser("check", {
      wrap: p,
      matcher: function(state, cont) {
        p = resolve(p);
        return p.parse(state, function(rv) {
          if (!rv.ok) {
            return cont(rv);
          }
          return cont(new Match(state, rv.match, rv.commit));
        });
      }
    });
  };

  commit = function(p) {
    p = implicit(p);
    return parser.newParser("commit", {
      wrap: p,
      matcher: function(state, cont) {
        p = resolve(p);
        return p.parse(state, function(rv) {
          if (!rv.ok) {
            return cont(rv);
          }
          rv.commit = true;
          return cont(rv);
        });
      }
    });
  };

  not_ = function(p) {
    p = implicit(p);
    return parser.newParser("not", {
      nested: [p],
      describer: function(ps) {
        return "not(" + (ps.join()) + ")";
      },
      matcher: function(state, cont) {
        p = resolve(p);
        return p.parse(state, (function(_this) {
          return function(rv) {
            if (rv.ok) {
              return _this.fail(state, cont);
            } else {
              return cont(new Match(state, "", rv.commit));
            }
          };
        })(this));
      }
    });
  };

  drop = function(p) {
    return implicit(p).onMatch(function(x) {
      return null;
    });
  };

  chain = function(p1, p2, combiner) {
    return parser.newParser("chain", {
      nested: [p1, p2],
      describer: function(ps) {
        return "" + ps[0] + " then " + ps[1];
      },
      matcher: function(state, cont) {
        p1 = resolve(p1);
        return p1.parse(state, function(rv1) {
          if (!rv1.ok) {
            return cont(rv1);
          }
          p2 = resolve(p2);
          return p2.parse(rv1.state, function(rv2) {
            if (!rv2.ok) {
              if (rv1.commit) {
                rv2.abort = true;
              }
              return cont(rv2);
            }
            return cont(new Match(rv2.state.backfill(rv1.state), combiner(rv1.match, rv2.match), rv2.commit || rv1.commit));
          });
        });
      }
    });
  };

  seq = function() {
    var p, p0, parsers;
    parsers = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    parsers = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = parsers.length; _i < _len; _i++) {
        p = parsers[_i];
        _results.push(implicit(p));
      }
      return _results;
    })();
    p0 = parsers.shift();
    if (parsers.length === 0) {
      return defer(p0).onMatch(function(m) {
        return [m];
      });
    }
    return chain(p0, seq.apply(null, parsers), function(rv1, rv2) {
      var rv;
      if (rv1 != null) {
        rv = rv2.slice(0);
        rv.unshift(rv1);
      } else {
        rv = rv2;
      }
      return rv;
    });
  };

  seqIgnore = function() {
    var ignore, newseq, p, parsers, _i, _len;
    ignore = arguments[0], parsers = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    parsers = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = parsers.length; _i < _len; _i++) {
        p = parsers[_i];
        _results.push(implicit(p));
      }
      return _results;
    })();
    newseq = [];
    for (_i = 0, _len = parsers.length; _i < _len; _i++) {
      p = parsers[_i];
      newseq.push(optional(ignore).drop());
      newseq.push(p);
    }
    return seq.apply(null, newseq);
  };

  alt = function() {
    var p, parsers;
    parsers = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    parsers = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = parsers.length; _i < _len; _i++) {
        p = parsers[_i];
        _results.push(implicit(p));
      }
      return _results;
    })();
    return parser.newParser("alt", {
      nested: parsers,
      describer: function(ps) {
        return "(" + ps.join(" or ") + ")";
      },
      matcher: function(state, cont) {
        var aborting, _i, _len, _results;
        parsers = (function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = parsers.length; _i < _len; _i++) {
            p = parsers[_i];
            _results.push(resolve(p));
          }
          return _results;
        })();
        aborting = false;
        _results = [];
        for (_i = 0, _len = parsers.length; _i < _len; _i++) {
          p = parsers[_i];
          _results.push((function(p) {
            return state.addJob(((function(_this) {
              return function() {
                return "alt: " + state + ", " + p;
              };
            })(this)), function() {
              if (aborting) {
                return;
              }
              return p.parse(state, function(rv) {
                if (rv.abort) {
                  aborting = true;
                }
                return cont(rv);
              });
            });
          })(p));
        }
        return _results;
      }
    });
  };

  repeat = function(p, minCount, maxCount) {
    var countMessage;
    if (minCount == null) {
      minCount = 0;
    }
    if (maxCount == null) {
      maxCount = null;
    }
    p = implicit(p);
    if (maxCount != null) {
      countMessage = "{" + minCount + ", " + maxCount + "}";
    } else {
      countMessage = "{" + minCount + "+}";
      maxCount = Math.pow(2, 31);
    }
    return parser.newParser("repeat", {
      nested: [p],
      describer: function(ps) {
        return "(" + (ps.join()) + ")" + countMessage;
      },
      matcher: function(state, cont) {
        var count, nextCont, origState;
        p = resolve(p);
        origState = state;
        count = 0;
        nextCont = (function(_this) {
          return function(rv, list, lastState) {
            if (list == null) {
              list = [];
            }
            if (lastState == null) {
              lastState = origState;
            }
            if (!rv.ok) {
              if (rv.abort) {
                return cont(rv);
              }
              if (count >= minCount) {
                return cont(new Match(lastState.backfill(origState), list, rv.commit));
              }
              return cont(new NoMatch(origState, "Expected " + (_this.description())));
            }
            count += 1;
            if (rv.match != null) {
              list = list.slice(0);
              list.push(rv.match);
            }
            if (count < maxCount) {
              if (rv.state.loc.pos === origState.loc.pos) {
                throw new Error("Repeating parser isn't making progress: " + rv.state.loc.pos + "=" + origState.loc.pos + " " + p);
              }
              return rv.state.addJob((function() {
                return "repeat: " + state + ", " + (p.description());
              }), function() {
                return p.parse(rv.state, function(x) {
                  return nextCont(x, list, rv.state);
                });
              });
            } else {
              return cont(new Match(rv.state.backfill(origState), list, rv.commit));
            }
          };
        })(this);
        return p.parse(origState, nextCont);
      }
    });
  };

  repeatIgnore = function(ignore, p, minCount, maxCount) {
    var p2;
    if (minCount == null) {
      minCount = 0;
    }
    if (maxCount == null) {
      maxCount = null;
    }
    p2 = seq(optional(ignore).drop(), p).onMatch(function(x) {
      return x[0];
    });
    return repeat(p2, minCount, maxCount);
  };

  repeatSeparated = function(p, separator, minCount, maxCount) {
    var p2;
    if (separator == null) {
      separator = "";
    }
    if (minCount == null) {
      minCount = 1;
    }
    if (maxCount == null) {
      maxCount = null;
    }
    p2 = seq(drop(separator), p).onMatch(function(x) {
      return x[0];
    });
    return seq(p, repeat(p2, minCount - 1, maxCount != null ? maxCount - 1 : maxCount)).onMatch(function(x) {
      return [x[0]].concat(x[1]);
    });
  };

  reduce = function(p, separator, accumulator, reducer, minCount, maxCount) {
    if (separator == null) {
      separator = "";
    }
    if (accumulator == null) {
      accumulator = null;
    }
    if (reducer == null) {
      reducer = null;
    }
    if (minCount == null) {
      minCount = 1;
    }
    if (maxCount == null) {
      maxCount = null;
    }
    if (accumulator == null) {
      accumulator = function(x) {
        return [x];
      };
    }
    if (reducer == null) {
      reducer = function(sum, sep, x) {
        return sum.push(x);
      };
    }
    return seq(p, repeat(seq(separator, p), minCount - 1, maxCount != null ? maxCount - 1 : maxCount)).onMatch(function(x) {
      if (x.length > 0) {
        return [accumulator(x[0])].concat(x[1]).reduce(function(sum, item) {
          return reducer(sum, item[0], item[1]);
        });
      } else {
        return x[0];
      }
    });
  };

  exports.optional = optional;

  exports.check = check;

  exports.commit = commit;

  exports.not_ = not_;

  exports.drop = drop;

  exports.chain = chain;

  exports.seq = seq;

  exports.seqIgnore = seqIgnore;

  exports.alt = alt;

  exports.repeat = repeat;

  exports.repeatIgnore = repeatIgnore;

  exports.repeatSeparated = repeatSeparated;

  exports.reduce = reduce;

}).call(this);
