// Generated by CoffeeScript 1.7.1
(function() {
  var WeakMap, defer, fromLazyCache, implicit, lazyCache, parser, resolve;

  WeakMap = require('weakmap');

  parser = require('./parser');

  lazyCache = new WeakMap();

  fromLazyCache = function(p) {
    var memo;
    memo = lazyCache.get(p);
    if (memo == null) {
      memo = p();
      lazyCache.set(p, memo);
    }
    return memo;
  };

  defer = function(p) {
    return parser.newParser("defer", {
      wrap: p,
      matcher: function(state, cont) {
        p = resolve(p);
        return p.parse(state, cont);
      }
    });
  };

  implicit = function(p) {
    var className, combiners;
    parser = require('./parser');
    combiners = require('./combiners');
    if (typeof p === "string") {
      return parser.string(p);
    }
    className = Object.prototype.toString.call(p).slice(1, -1).split(" ")[1];
    if (className === "RegExp") {
      return parser.regex(p);
    }
    if (className === "Array") {
      return combiners.seq.apply(combiners, p);
    }
    return p;
  };

  resolve = function(p) {
    if (!(typeof p === "function")) {
      return implicit(p);
    }
    p = fromLazyCache(p);
    p = implicit(p);
    if (p == null) {
      throw new Error("Can't resolve parser");
    }
    return p;
  };

  exports.defer = defer;

  exports.implicit = implicit;

  exports.resolve = resolve;

}).call(this);
