// Generated by CoffeeScript 1.7.1
(function() {
  var DebugGraph, Match, NoMatch, Parser, ParserState, combiners, consume, debug_graph, end, helpers, implicit, newParser, parse, parser_state, regex, reject, resolve, string, succeed, util, _count, _parser_id,
    __slice = [].slice;

  util = require('util');

  combiners = require('./combiners');

  debug_graph = require('./debug_graph');

  helpers = require('./helpers');

  parser_state = require('./parser_state');

  DebugGraph = debug_graph.DebugGraph;

  implicit = helpers.implicit;

  resolve = helpers.resolve;

  ParserState = parser_state.ParserState;

  Match = parser_state.Match;

  NoMatch = parser_state.NoMatch;

  _parser_id = 0;

  newParser = function(kind, options) {
    if (options == null) {
      options = {};
    }
    if (options.nested == null) {
      options.nested = [];
    }
    if (options.describer == null) {
      options.describer = kind;
    }
    if (options.matcher == null) {
      options.matcher = function(state, cont) {
        throw new Error("Undefined matcher");
      };
    }
    if (options.wrap != null) {
      options.nested = [options.wrap];
      options.describer = function(ps) {
        return ps.join();
      };
    }
    return new Parser(kind, options.nested, options.describer, options.matcher);
  };

  _count = 0;

  Parser = (function() {
    function Parser(kind, nested, describer, matcher) {
      this.kind = kind;
      this.nested = nested;
      this.describer = describer;
      this.matcher = matcher;
      this.id = _parser_id++;
    }

    Parser.prototype.nestedList = function() {
      var rv;
      if (this.recursing) {
        return "...";
      }
      if (this.nested.length === 0) {
        return "";
      }
      this.recursing = true;
      rv = this.nested.map(function(p) {
        return resolve(p).nestedList();
      }).join(", ");
      this.recursing = false;
      return "(" + rv + ")";
    };

    Parser.prototype.description = function() {
      var ps;
      if (this.recursing) {
        return "...";
      }
      if (typeof this.describer === "string") {
        return this.describer;
      }
      this.recursing = true;
      ps = this.nested.map(function(p) {
        return resolve(p).description();
      });
      this.recursing = false;
      this.describer = this.describer(ps);
      return this.describer;
    };

    Parser.prototype.toString = function() {
      return ("Parser[" + this.id + ", " + this.kind + "]") + this.nestedList();
    };

    Parser.prototype.toDot = function(maxLength) {
      var data, edges, nodes, seen, traverse;
      if (maxLength == null) {
        maxLength = 40;
      }
      seen = {};
      nodes = [];
      edges = [];
      traverse = function(parser) {
        var p, _i, _len, _ref, _results;
        seen[parser.id] = true;
        nodes.push({
          id: parser.id,
          kind: parser.kind,
          description: parser.description()
        });
        _ref = parser.nested;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          p = _ref[_i];
          p = resolve(p);
          edges.push({
            from: parser.id,
            to: p.id
          });
          if (seen[p.id] == null) {
            _results.push(traverse(p));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };
      traverse(this);
      edges = edges.map(function(e) {
        return "  \"" + e.from + "\" -> \"" + e.to + "\";";
      });
      nodes = nodes.map(function(n) {
        var description, kind, label;
        description = n.description.length > maxLength ? "" + n.description.slice(0, maxLength) + "..." : n.description;
        description = description.replace(/\\/g, "\\\\").replace(/"/g, "\\\"");
        kind = n.kind.replace(/\\/g, "\\\\").replace(/"/g, "\\\"");
        label = "" + kind + "\\n" + description;
        return "  \"" + n.id + "\" [label=\"" + label + "\"];";
      });
      data = ["digraph packrattle {", "  node [fontname=Courier];"];
      data = data.concat(edges);
      data.push("");
      data = data.concat(nodes);
      data.push("}");
      return data.join("\n") + "\n";
    };

    Parser.prototype.fail = function(state, cont) {
      return cont(new NoMatch(state, "Expected " + this.description()));
    };

    Parser.prototype.parse = function(state, cont) {
      var entry, r, _i, _len, _ref, _results;
      _count += 1;
      state = state.deeper(this);
      entry = state.getCache(this);
      if (entry.continuations.length === 0) {
        entry.continuations.push(cont);
        return state.addJob(((function(_this) {
          return function() {
            return "parse: " + state + ", " + (_this.toString());
          };
        })(this)), (function(_this) {
          return function() {
            return _this.matcher(state, function(rv) {
              var c, found, r, _i, _j, _len, _len1, _ref, _ref1, _results;
              found = false;
              _ref = entry.results;
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                r = _ref[_i];
                if (r.equals(rv)) {
                  found = true;
                }
              }
              if (!found) {
                entry.results.push(rv);
                _ref1 = entry.continuations;
                _results = [];
                for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
                  c = _ref1[_j];
                  _results.push(c(rv));
                }
                return _results;
              }
            });
          };
        })(this));
      } else {
        entry.continuations.push(cont);
        _ref = entry.results;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          r = _ref[_i];
          _results.push(cont(r));
        }
        return _results;
      }
    };

    Parser.prototype.run = function(text, options) {
      var e, rv;
      rv = consume(this, text, options);
      if (!rv.ok) {
        e = new Error(rv.message);
        e.state = rv.state;
        throw e;
      }
      return rv.match;
    };

    Parser.prototype.onFail = function(newMessage) {
      return newParser("onFail", {
        wrap: this,
        matcher: (function(_this) {
          return function(state, cont) {
            return _this.parse(state, function(rv) {
              if (rv.ok || rv.abort) {
                return cont(rv);
              }
              return cont(new NoMatch(rv.state, newMessage, rv.abort));
            });
          };
        })(this)
      });
    };

    Parser.prototype.onMatch = function(f) {
      return newParser("onMatch", {
        wrap: this,
        matcher: (function(_this) {
          return function(state, cont) {
            return _this.parse(state, function(rv) {
              var e, result;
              if (!rv.ok) {
                return cont(rv);
              }
              if (typeof f === "function") {
                try {
                  result = f(rv.match, rv.state.flip());
                  if (result instanceof Parser) {
                    return result.parse(rv.state, cont);
                  } else {
                    return cont(new Match(rv.state, result, rv.commit));
                  }
                } catch (_error) {
                  e = _error;
                  return cont(new NoMatch(rv.state, e.toString(), rv.commit));
                }
              } else {
                return cont(new Match(rv.state, f, rv.commit));
              }
            });
          };
        })(this)
      });
    };

    Parser.prototype.matchIf = function(f) {
      return newParser("matchIf", {
        wrap: this,
        matcher: (function(_this) {
          return function(state, cont) {
            return _this.parse(state, function(rv) {
              if (!rv.ok) {
                return cont(rv);
              }
              if (!f(rv.match)) {
                return cont(new NoMatch(state, "Expected " + _this.description(), rv.commit));
              }
              return cont(rv);
            });
          };
        })(this)
      });
    };

    Parser.prototype.describe = function(message) {
      this.describer = function() {
        return message;
      };
      return this.onFail("Expected " + message);
    };

    Parser.prototype.then = function(p) {
      return combiners.chain(this, p, function(a, b) {
        return [a, b];
      });
    };

    Parser.prototype.or = function() {
      var others;
      others = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return combiners.alt.apply(combiners, [this].concat(__slice.call(others)));
    };

    Parser.prototype.optional = function(defaultValue) {
      if (defaultValue == null) {
        defaultValue = "";
      }
      return combiners.optional(this, defaultValue);
    };

    Parser.prototype.check = function() {
      return combiners.check(this);
    };

    Parser.prototype.commit = function() {
      return combiners.commit(this);
    };

    Parser.prototype.not_ = function() {
      return combiners.not_(this);
    };

    Parser.prototype.drop = function() {
      return combiners.drop(this);
    };

    Parser.prototype.repeat = function(minCount, maxCount) {
      return combiners.repeat(this, minCount, maxCount);
    };

    Parser.prototype.times = function(count) {
      return combiners.repeat(this, count, count);
    };

    return Parser;

  })();

  end = newParser("end", {
    matcher: function(state, cont) {
      if (state.loc.pos === state.internal.end) {
        return cont(new Match(state, null, false));
      } else {
        return this.fail(state, cont);
      }
    }
  });

  reject = newParser("reject", {
    matcher: function(state, cont) {
      return cont(new NoMatch(state, "failure"));
    }
  });

  succeed = function(v) {
    return newParser("succeed", {
      matcher: function(state, cont) {
        return cont(new Match(state, v, false));
      }
    });
  };

  string = function(s) {
    var len;
    len = s.length;
    return newParser("lit: '" + s + "'", {
      describer: "'" + s + "'",
      matcher: function(state, cont) {
        var candidate;
        candidate = state.internal.text.slice(state.loc.pos, state.loc.pos + len);
        if (candidate === s) {
          return cont(new Match(state.advance(len), candidate, false));
        } else {
          return this.fail(state, cont);
        }
      }
    });
  };

  regex = function(r) {
    var i, m, r2, source;
    i = r.ignoreCase ? "i" : "";
    m = r.multiline ? "m" : "";
    source = r.source[0] === "^" ? r.source : "^" + r.source;
    r2 = new RegExp(source, i + m);
    return newParser("re: " + (r.toString()), {
      describer: r.toString(),
      matcher: function(state, cont) {
        m = r2.exec(state.internal.text.slice(state.loc.pos));
        if (m != null) {
          return cont(new Match(state.advance(m[0].length), m, false));
        } else {
          return this.fail(state, cont);
        }
      }
    });
  };

  parse = function(p, str, options) {
    var failures, state, successes;
    if (options == null) {
      options = {};
    }
    _count = 0;
    state = str instanceof ParserState ? str : new ParserState(str);
    state.stateName = "start";
    if (options.debugGraph) {
      state.startDebugGraph();
    }
    p = resolve(p);
    successes = [];
    failures = [];
    state.addJob(((function(_this) {
      return function() {
        return "start: " + state + ", " + (p.toString());
      };
    })(this)), function() {
      return p.parse(state, function(rv) {
        if (rv.ok) {
          rv.state.logSuccess();
          return successes.push(rv);
        } else {
          rv.state.logFailure();
          return failures.push(rv);
        }
      });
    });
    while (state.internal.trampoline.ready() && successes.length === 0) {
      state.internal.trampoline.next();
    }
    failures.sort(function(a, b) {
      if (a.abort !== b.abort) {
        if (b.abort) {
          return 1;
        } else {
          return -1;
        }
      } else {
        return b.state.depth - a.state.depth;
      }
    });
    if (successes.length > 0) {
      return successes[0];
    } else {
      return failures[0];
    }
  };

  consume = function(p, str, options) {
    p = combiners.chain(implicit(p), end, function(a, b) {
      return a;
    });
    return parse(p, str, options);
  };

  exports.newParser = newParser;

  exports.Parser = Parser;

  exports.end = end;

  exports.reject = reject;

  exports.succeed = succeed;

  exports.string = string;

  exports.regex = regex;

  exports.parse = parse;

  exports.consume = consume;

}).call(this);
