// Generated by CoffeeScript 1.7.1
(function() {
  var PriorityQueue;

  PriorityQueue = (function() {
    function PriorityQueue() {
      this.queue = [];
    }

    PriorityQueue.prototype.length = function() {
      return this.queue.length;
    };

    PriorityQueue.prototype.isEmpty = function() {
      return this.queue.length === 0;
    };

    PriorityQueue.prototype.get = function() {
      if (this.queue.length === 0) {
        throw new Error("Queue is empty");
      }
      return this.queue.pop().item;
    };

    PriorityQueue.prototype.put = function(item, priority) {
      return this.putRange(0, this.queue.length, item, priority);
    };

    PriorityQueue.prototype.putRange = function(left, right, item, priority) {
      var n;
      if (left >= right) {
        return this.queue.splice(left, 0, {
          item: item,
          priority: priority
        });
      }
      n = left + Math.floor((right - left) / 2);
      if (this.queue[n].priority >= priority) {
        return this.putRange(left, n, item, priority);
      } else {
        return this.putRange(n + 1, right, item, priority);
      }
    };

    PriorityQueue.prototype.inspect = function() {
      return this.queue.slice(0).reverse();
    };

    return PriorityQueue;

  })();

  exports.PriorityQueue = PriorityQueue;

}).call(this);
