// Generated by CoffeeScript 1.7.1
(function() {
  var PriorityQueue, Trampoline;

  PriorityQueue = require("./priority_queue").PriorityQueue;

  Trampoline = (function() {
    function Trampoline(state) {
      this.state = state;
      this.work = new PriorityQueue();
      this.cache = {};
    }

    Trampoline.prototype.push = function(priority, description, job) {
      return this.work.put({
        description: description,
        job: job
      }, priority);
    };

    Trampoline.prototype.size = function() {
      return this.work.length();
    };

    Trampoline.prototype.next = function() {
      var item;
      item = this.work.get();
      if (item != null) {
        return item.job();
      }
    };

    Trampoline.prototype.ready = function() {
      return !this.work.isEmpty();
    };

    Trampoline.prototype.getCache = function(parser, state) {
      var entry, x;
      x = this.cache[parser.id];
      if (x == null) {
        this.cache[parser.id] = x = {};
      }
      entry = x[state.loc.pos];
      if (entry == null) {
        x[state.loc.pos] = entry = {
          continuations: [],
          results: []
        };
      }
      return entry;
    };

    return Trampoline;

  })();

  exports.Trampoline = Trampoline;

}).call(this);
